/* =====================================================================
 *  mkTCH - making 'mTCH'
 * =====================================================================
 *  
 *
 *    30,40 ōvOȂ̂ŃG[`FbN͊FɓłB
 *    VXeɒvIȑ^邱Ƃ͖Ǝv܂AҒʂ
 *    ȂƂ͂邩܂B
 *
 *    nbLă_TR[hł (^^;
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const char usage [] =
  "usage: mkTCH [option(s)]\n"
  "  options\n"
  "    -t<n>        Đ (b) ̎w               (default    15.0)\n"
  "\n"
  "    -q<n>        rectImg TYPE w                  (default       4)\n"
  "                 'PAT4' <n> = 4, 'PAT3' <n> = 3, 'PAT2' <n> = 2\n"
  "\n"
  "    -p<n>,<m>    rectImg IDw                     (default 128,278)\n"
  "                 ĐJn ID <n>, I ID <m>\n"
  "\n"
  "    -s<n>        ADPCM 'BEEP'IDw                 (default     128)\n"
  "                 f[^̏ꍇ <n> = 0\n"
  "\n"
  "    -i<path>     'mTCH.inc' ̃pX                  (default     \".\")\n"
  "";

int tracks = 2;			/* track 		*/
int times  = 1500;		/* Đ x 100	*/
int type   = 4;			/* rectImg TYPE		*/
int spat4  = 128;		/* 'PAT4' JnID	*/
int epat4  = 128+150;		/* 'PAT4' IID	*/
int xpat4  = 1500;		/* 'PAT4' i[ x 100	*/
int beep   = 128;		/* 'BEEP' ID		*/
char inc [128] = ".";		/* 'mTCH.inc' ̃pX	*/

void
main (int argc, char* argv [])
{
  int i, j;

  if (argc < 2) {
    printf ("\n%s\n", usage);
    return;
  }

  while (++argv, --argc) {
    if (**argv == '-') {
      switch (*(*argv + 1)) {
      case 'h':
      case '?':
	printf (usage);
	return;
      case 't':
	times = (int) (atof (*argv + 2) * 100);
	break;
      case 'q':
	type = atoi (*argv + 2);
	break;
      case 'p':
	sscanf (*argv + 2, "%d,%d", &spat4, &epat4);
	if (epat4 <= spat4) epat4 = spat4 + 150;
	break;
      case 's':
	beep = atoi (*argv + 2);
	break;
      case 'i':
	if (*(*argv + 2)) strcpy (inc, *argv + 2);
	break;
      }
    }
  }

  xpat4 = epat4 - spat4 + 1;

  printf ("; =====================================================================\n");
  printf (";  mTCH - time chart resource for \"MOVIE\"\n");
  printf ("; =====================================================================\n");
  printf (";\n\n");

  printf ("\t.include %s/mTCH.inc\n\n", inc);
  printf ("\t.data\n\n");

  printf (";\n; header block\n;\n\n");
  printf ("\t.dc.w\t0\t\t* 'mTCH' x\n");
  printf ("\t.dc.w\t%d\t\t* i[ track \n", tracks);
  printf ("\t.dc.l\t%d\t\t* Đ\n\n", times);

  printf (";\n; 0 track\n;\n\n");
  printf ("\t.dc.l\tmATR_PAT%d\t* track \n\n", type);

  for (i = 0; i < (times / 100); i++) {
    printf ("\t; %d.0sec\n\n", i + 1);
    for (j = 0; j < 10 && (i * 100 + j * 10) < times; j++) {
      if (j == 0 || j == 5) {
	printf ("\t.dc.w\t");
      } else {
	printf (",");
      }
      printf ("%d,0,0,0", spat4 + (xpat4 * (i * 100 + j * 10)) / times);
      if (j == 4) printf ("\n");
      if (j == 9) printf ("\n\n");
    }
  }

  printf (";\n; 1 track\n;\n\n");
  printf ("\t.dc.l\tmATR_BEEP\t* track \n\n");

  printf ("\t; %d.0sec\n\n", 1);
  printf ("\t.dc.w\t%d,0\n", beep);
  printf ("\t.dc.l\t%d\n\n", (times * 7800) / 100);

  printf ("\t.dc.w\t0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0\n");
  printf ("\t.dc.w\t0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0\n\n");

  for (i = 1; i < (times / 100); i++) {
    printf ("\t; %d.0sec\n\n", i + 1);
    for (j = 0; j < 10 && (i * 100 + j * 10) < times; j++) {
      if (j == 0 || j == 5) {
	printf ("\t.dc.w\t");
      } else {
	printf (",");
      }
      printf ("0,0,0,0");
      if (j == 4) printf ("\n");
      if (j == 9) printf ("\n\n");
    }
  }

  printf (";\n");
  printf ("; =====================================================================\n");
  printf (";  end of 'mTCH'\n");
  printf ("; =====================================================================\n");
  printf (";\n");
}

/* =====================================================================
 *  end of mkTCH.c
 * =====================================================================
 * $Log$
 */
