/* =====================================================================
 *  ptgen - wTCY 'PAT4'or'PAT3' fb`
 * =====================================================================
 *@
 *
 *  	ptgen [-p<n>] [-r<whidth>,<height>] <output file>
 *
 *  
 *
 *@@wTCY 'PAT3'or'PAT4' f[^t@Cfb`܂B
 *
 *	-p<n>		^Cvw 'PAT3' <n> = 3, 'PAT4' <n> = 4
 *	-h<whidth>	̎w
 *	-v<height>	̎w
 *
 *  
 *
 *    30,40 ōvOȂ̂ŃG[`FbN͊FɓłB
 *    VXeɒvIȑ^邱Ƃ͖Ǝv܂AҒʂ
 *    ȂƂ͂邩܂B
 *
 *@@ȂA҂͂̃vOɊւ؂̌^`܂B
 *    in the Public Domain ĉB
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <error.h>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <sxdef.h>

char const progname [] = "ptgen";
char const usage_string [] = "usage: ptgen [-p<n>] [-h<width>] [-v<height>] <output file>";

#define BUFMAX		(4096)
char buf [BUFMAX];

int
main (int argc, char* argv [])
{
  int pages = 3;
  rect rct = (rect) {0, 0, 256, 128};

  int ofd;
  char ofn [128];

  if (argc < 2) {
    printf ("%s\n", usage_string);
    return 1;
  }

  *ofn = 0;

  while (++argv, --argc) {
    if (**argv == '-') {
      switch (*(*argv + 1)) {
      case 'p':
	pages = atoi (*argv + 2);
	break;
      case 'h':
	rct.right = atoi (*argv + 2);
	break;
      case 'v':
	rct.bottom = atoi (*argv + 2);
	break;
      }
    } else {
      if (!*ofn) {
	strcpy (ofn, *argv);
      }
    }
  }

  if (!*ofn) {
    printf ("%s\n", usage_string);
    return 1;
  }

  printf ("type = 'PAT%d', size = %d, %d\n", pages, rct.right, rct.bottom);

  {
    int fsiz;		/* t@CTCY	*/

    fsiz = (((rct.right / 8) + (rct.right % 8)) * rct.bottom) * pages;

    ofd = open (ofn, O_WRONLY | O_BINARY | O_CREAT | O_TRUNC, S_IREAD | S_IWRITE);
    if (ofd < 0) {
      perror (progname);
      return 2;
    }

    write (ofd, &rct, sizeof (rect));

    memset (buf, 0x0ff, BUFMAX);

    while (fsiz > 0) {
      write (ofd, buf, min (fsiz, BUFMAX));
      fsiz -= BUFMAX;
    }

    close (ofd);
  }

  return 0;
}
