/* =====================================================================
 *  MOVIE.h - Animation manager
 * =====================================================================
 * $Revision: 1.10 $
 * $Date: 1994/01/04 19:33:23 $
 * $Author: hidori $
 */

#ifndef MOVIE_H
#define MOVIE_H

#include "misc.h"

/* =====================================================================
 *  const
 * =====================================================================
 */

#ifndef MOVIE_FILENAMEL
# define MOVIE_FILENAMEL	(128)		/* t@C̍ő咷	*/
#endif /* MOVIE_FILENAMEL */

#ifndef defaultMovieStatStr
# define defaultMovieStatStr	"1001"		/* ftHgĐ	*/
#endif /* defaultMovieStatStr */

/* =====================================================================
 *  macro
 * =====================================================================
 */

/* =====================================================================
 *  typedef
 * =====================================================================
 */

typedef struct _mTimeChart {
  unsigned short level;		/* i[`				*/
  unsigned short tracks;	/* i[ track 			*/
  unsigned long times;		/* Đ(sec) x 100			*/
  unsigned char chunk [1];	/* f[^gbN			*/
} mTimeChart;

typedef struct _mChunk_SKEL {
  unsigned short obj1;
  unsigned short obj2;
  unsigned short obj3;
  unsigned short obj4;
} mChunk_SKEL;

typedef struct _mChunk_PAT4 {
  unsigned short id;		/* 'PAT4' ID				*/
  unsigned short reserve2;
  unsigned short reserve3;
  unsigned short reserve4;
} mChunk_PAT4;

typedef struct _mChunk_BEEP {
  unsigned short id;		/* 'BEEP' ID				*/
  unsigned short reserve2;
  unsigned long times;		/* 'BEEP' L byte 			*/
} mChunk_BEEP;

typedef union _mChunk {
  mChunk_SKEL skel;
  mChunk_PAT4 pat4;
  mChunk_BEEP beep;
} mChunk;

typedef struct _mTrack {
  unsigned long attrib;
  mChunk chunk [1];
} mTrack;

typedef struct _MOVIE {
  handle resHdl;		/* i[Ă郊\[Xnh	*/
  graph* mGraph;		/* `Ώۂgraph			*/
  rect mRect;			/* graph̕\̈			*/
  rect bounds;			/* \TCY				*/
  unsigned long cells;		/* i[R}				*/
  mTimeChart** mTch;		/* ^C`[g			*/
  unsigned short pages;		/* ǗptO				*/
  unsigned char hide;		/* \				*/
  unsigned char play;		/* vCtO				*/
  unsigned char pause;		/* |[YtO				*/
  unsigned char repeat;		/* s[gtO			*/
  unsigned long runs;		/* ĐJňoߎ		*/
  unsigned long prev;		/* O`悵			*/
  short ttlImgID;		/* ^Cg摜\[XID		*/
  handle ttlImgHdl;		/* ^Cg摜\[Xnh		*/
  short curImgID;		/* `撆̉摜\[XID		*/ 
  handle curImgHdl;		/* `撆̉摜\[Xnh		*/ 
  short curSndID;		/* Đ̉\[XID		*/
  handle curSndHdl;		/* Đ̉\[Xnh		*/
  unsigned long reserve [8];	/* VXe\			*/
} MOVIE;

/* =====================================================================
 *  functions
 * =====================================================================
 */

MOVIE** movieOpen (char* fn, graph* gPtr, rect* rct, const int md);
void movieDispose (MOVIE** mHdl);

void movieDraw (MOVIE** movieHdl, tsevent* eventRecord);

void moviePlay (MOVIE** movieHdl);
void movieStop (MOVIE** movieHdl);
void moviePlayInvert (MOVIE** movieHdl);

void moviePause (MOVIE** movieHdl);
void movieUnPause (MOVIE** movieHdl);
void moviePauseInvert (MOVIE** movieHdl);

void movieRepeat (MOVIE** movieHdl);
void movieUnRepeat (MOVIE** movieHdl);
void movieRepeatInvert (MOVIE** movieHdl);

void movieShow (MOVIE** movieHdl);
void movieHide (MOVIE** movieHdl);

char* movieGetStatusStr (MOVIE** movieHdl);
void movieSetStatusStr (MOVIE** movieHdl, const char* statStr);

#endif /* MOVIE_H */

/* =====================================================================
 *  end of MOVIE.h
 * =====================================================================
 * $Log: MOVIE.h,v $
 * Revision 1.10  1994/01/04  19:33:23  hidori
 * EI[fBIĐɎbΉ
 *
 * Revision 1.9  1994/01/01  11:06:36  hidori
 * *** empty log message ***
 *
 * Revision 1.8  1993/08/16  16:35:40  hidori
 * E] lock, unlock ̍폜
 * EnhQƂ̈ꕔ|C^QƂɕύXA}
 *
 * Revision 1.7  1993/08/16  13:41:59  hidori
 * EĐ~,ĐԔ]̒ǉ
 *
 * Revision 1.6  1993/08/14  17:55:32  hidori
 * EĐԎ擾^ݒ胁\bh̒ǉ
 *
 * Revision 1.5  1993/08/14  13:01:14  hidori
 * EnCh̎
 *
 * Revision 1.4  1993/08/14  12:15:28  hidori
 * E|[YAs[gԎw̎
 *
 * Revision 1.3  1993/08/12  16:34:06  hidori
 * E'mTCH' ͕̋
 *
 * Revision 1.2  1993/08/11  11:16:06  hidori
 * E^C`[g̎QƂ
 * E|[Y̎
 *
 * Revision 1.1  1993/08/05  13:51:09  hidori
 * Initial revision
 *
 */
