/* =====================================================================
 *  Skel.c - Skelton program for SX-WINDOW Apps.
 * =====================================================================
 * $Revision: 1.11 $
 * $Date: 1994/01/04 19:33:23 $
 * $Author: hidori $
 */

static const char rcsid [] = "$Id: Skel.c,v 1.11 1994/01/04 19:33:23 hidori Exp hidori $";
const char _sxkernelcomm [] = "sxwin.x";

#define	MAIN

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/dos.h>

#include <sxlib.h>

#include "Skel.h"
#include "MOVIE.h"

/* =====================================================================
 *  global
 * =====================================================================
 */

EXTERN MOVIE** movieHdl;
EXTERN rect movieRect = {0,0,0x7fff,0x7fff};
EXTERN char movieFilename [MOVIE_FILENAMEL];
EXTERN char movieTitle [MOVIE_FILENAMEL];

EXTERN int movieKick = 0;

EXTERN control** playBttn;
EXTERN control** pauseBttn;
EXTERN control** stopBttn;

/* =====================================================================
 *  main - main procedure
 * =====================================================================
 */

void
main (int argc, char *argv [])
{
  int i, r;
  int loop = 1;

  EMEnCross ();
  r = initProc (argc, argv);
  EMDeCross ();

  if (!r) tiniProc (0, 1);

  while (loop) {
    TSEventAvail (eventMask, &eventRecord);
    for (i = 0; i < windowMax; i++) {
      thisWindow = &(_window [i]);
      if (thisWindow->windowPtr && thisWindow->proc [eventRecord.what]) {
	loop = thisWindow->proc [eventRecord.what] ();
      }
    }
  }

  tiniProc (0, 0);
}

/* =====================================================================
 *  initProc - for initialize and set up
 * =====================================================================
 */

int
initProc (int argc, char *argv [])
{
  char activeWindow [windowMax];
  char movieStatStr [32];

  strcpy (progname, *argv);

  TSSetAbort (tiniProc, SXFAITALERROR);
  taskId = TSGetID ();

  localRscHdl = getLocalRsc (argv [0], localRscFilename);
  if (!localRscHdl) {
    TSErrDialogN (1, "[J\[X܂");
    return 0;
  }

  strcpy (activeWindow, defaultActiveWindow);
  strcpy (movieStatStr, defaultMovieStatStr);

  movieHdl = NULL;
  *movieFilename = 0;
  *movieTitle    = 0;

  while (++argv, --argc) {
    if (**argv == '-') {
      switch (*(*argv + 1)) {
      case 'w':	/* SX-WINDOW system option	*/
	break;
      case 't':	/* window titile		*/
	strcpy (movieTitle, (*(*argv + 2) ? *argv + 2 : "Untitled"));
	break;
      case 'a':	/* active window list		*/
	strcpy (activeWindow, (*(*argv + 2) ? *argv + 2 : defaultActiveWindow));
	break;
      case 's':	/* window position		*/
	{
	  if (strlen (*argv) > 4) {
	    int windowNum = *(*argv + 2) - '0';

	    if (0 <= windowNum && windowNum <= 2) {
	      _window_pos_list [windowNum].flag = 1;
	      sscanf (*argv + 4, "%x", &(_window_pos_list [windowNum].pos));
	    }
	  }
	}
	break;
      case 'z':	/* misc option			*/
	strcpy (movieStatStr, (*(*argv + 2) ? *argv + 2 : defaultMovieStatStr));
	break;
      default:
	TSErrDialogN (1, "m̃IvVł");
      }
    } else {
      if (!*movieFilename) strcpy (movieFilename, *argv);
    }
  }

  if (!openInfoWindow (2)) return 0;
  if (activeWindow [2] > '0') {
    infoWindow.option &= (~WINDOW_OPT_HIDE);
    WMShow (infoWindow.windowPtr);
  } else {
    infoWindow.option |= WINDOW_OPT_HIDE;
    WMHide (infoWindow.windowPtr);
  }

  if (!openIconWindow (1)) return 0;
  if (activeWindow [1] > '0') {
    iconWindow.option &= (~WINDOW_OPT_HIDE);
    WMShow (iconWindow.windowPtr);
  } else {
    iconWindow.option |= WINDOW_OPT_HIDE;
    WMHide (iconWindow.windowPtr);
  }

  if (!openMainWindow (0)) return 0;
  if (*movieFilename) {
    point newsize;

    movieHdl = movieOpen (movieFilename, (graph*) mainWindow.windowPtr, &movieRect, 0);
    if (!movieHdl) {
      tsevent dummyEventRecord = eventRecord;

      dummyEventRecord.what = E_UPDATE;
      movieDraw (movieHdl, &dummyEventRecord);
      thisWindow->updateFlag = 1;

      *movieFilename = 0;
      *movieTitle = 0;
    } else {
      movieKick = 1;
      mainWindow.updateFlag = 1;
      if (*movieStatStr) movieSetStatusStr (movieHdl, movieStatStr);
      newsize.x = (*movieHdl)->bounds.right;
#ifdef USE_CTRL_PANEL
      newsize.y = (*movieHdl)->bounds.bottom + hscBarHeight;
#else /* !USE_CTRL_PANEL */
      newsize.y = (*movieHdl)->bounds.bottom;
#endif /* USE_CTRL_PANEL */
      WMShow (mainWindow.windowPtr);
      WMSize (mainWindow.windowPtr, *(point_t*) &newsize, 1);
#ifdef USE_CTRL_PANEL
      if (playBttn) {
	point newPos = (point) {
	  (((mainWindow.windowPtr)->wGraph).grRect).left,
	  (((mainWindow.windowPtr)->wGraph).grRect).bottom - 16,
	};

	CMHide (playBttn);
	CMMove (playBttn, *(point_t*) &newPos);
	CMShow (playBttn);
      }

      if (pauseBttn){
	point newPos = (point) {
	  (((mainWindow.windowPtr)->wGraph).grRect).left + 17,
	  (((mainWindow.windowPtr)->wGraph).grRect).bottom - 16,
	};

	CMHide (pauseBttn);
	CMMove (pauseBttn, *(point_t*) &newPos);
	CMShow (pauseBttn);
      }

      if (stopBttn) {
	point newPos = (point) {
	  (((mainWindow.windowPtr)->wGraph).grRect).left + 34,
	  (((mainWindow.windowPtr)->wGraph).grRect).bottom - 16,
	};

	CMHide (stopBttn);
	CMMove (stopBttn, *(point_t*) &newPos);
	CMShow (stopBttn);
      }
#endif /* USE_CTRL_PANEL */
    }
  }

  if (*movieTitle) {
    windowSetTitle (&mainWindow, movieTitle);
  }

  if (activeWindow [0] > '0') {
    mainWindow.option &= (~WINDOW_OPT_HIDE);
    WMShow (mainWindow.windowPtr);
  } else {
    mainWindow.option |= WINDOW_OPT_HIDE;
    WMHide (mainWindow.windowPtr);
  }

  return 1;
}

/* =====================================================================
 *  tiniProc - for terminate
 * =====================================================================
 */

void
tiniProc (int endFlag, long param)
{
  int i;

  if (!endFlag) {
    for (i = 0; i < windowMax; i++) {
      windowClose (&(_window [i]));
    }
    if (localRscHdl) {
      TSCurResSet (localRscHdl);
      TSResRemove ();
    }
  }

  exit (param);
}

/* =====================================================================
 *  setTdb - save command line
 * =====================================================================
 */

int
setTdb (void)
{
  char cBuf [256];
  task taskBuff;
  int i;

  TSGetTdb (&taskBuff, -1);

  *cBuf = 0;

  sprintf (cBuf + strlen (cBuf), "-a%s ", windowGetActiveList (_window, windowMax));

  for (i = 0; i < windowMax; i++) {
    windowSaveTdb (&(_window [i]), cBuf);
  }

  ztol (cBuf, &(taskBuff.command));
  TSSetTdb (&taskBuff, -1);

  return 1;
}

/* =====================================================================
 *  end of Skel.c
 * =====================================================================
 * $Log: Skel.c,v $
 * Revision 1.11  1994/01/04  19:33:23  hidori
 * EI[fBIĐɎbΉ
 *
 * Revision 1.10  1994/01/03  08:00:32  hidori
 * E'mTCH' Ȃ .FLM ̍ăT|[g
 *
 * Revision 1.9  1994/01/01  11:06:36  hidori
 * *** empty log message ***
 *
 * Revision 1.8  1993/09/04  02:45:34  hidori
 * ER}hCIvV̔ꕔύX
 *
 * Revision 1.7  1993/08/16  16:35:40  hidori
 * EnhpȂǂ̃}Nǉ
 *
 * Revision 1.6  1993/08/14  17:55:32  hidori
 * E"[r" ̃hOΉ
 *
 * Revision 1.5  1993/08/14  12:15:28  hidori
 * EWM_SAVE_TDB \bhւ̑Ή
 *
 * Revision 1.4  1993/08/13  03:16:51  hidori
 * EMOVIE ̔p mainWindow ̃fXgN^Ɉړ
 *
 * Revision 1.3  1993/08/12  16:34:06  hidori
 * EEBhE쐬^p̌
 *
 * Revision 1.2  1993/08/11  11:16:06  hidori
 * E^C`[g̎QƂ
 * E|[Y̎
 *
 * Revision 1.1  1993/08/05  13:51:09  hidori
 * Initial revision
 *
 */
