/* =====================================================================
 *  icon.c - icon window
 * =====================================================================
 * $Revision: 1.11 $
 * $Date: 1994/01/03 08:00:32 $
 * $Author: hidori $
 */

static const char rcsid [] = "$Id: icon.c,v 1.11 1994/01/03 08:00:32 hidori Exp $";

#define	ICON_WINDOW

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/dos.h>

#include <sxlib.h>

#include "Skel.h"
#include "MOVIE.h"

/* =====================================================================
 *  prototype
 * =====================================================================
 */

extern int openIconWIndow    (int windowNum);
static int disposeIconWindow (void);
static int saveTaskDB        (char* cmd);

static int iconIdleEvent           (void);
static int iconMouseLeftDownEvent  (void);
static int iconMouseRightDownEvent (void);
extern int keyDownEvent            (void);
static int iconUpdateEvent         (void);
extern int activateEvent           (void);
extern int systemEvent	           (void);

/* =====================================================================
 *  global
 * =====================================================================
 */

EXTERN MOVIE** movieHdl;
EXTERN rect movieRect;
EXTERN char movieFilename [MOVIE_FILENAMEL];
EXTERN char movieTitle [MOVIE_FILENAMEL];

static rectImg** iconImgHdl;
static menu** iconMenuHdl;

/* =====================================================================
 *  openIconWindow - iconWindow ̃I[v
 * =====================================================================
 */

int
openIconWindow (int windowNum)
{
  rect boundsRect;
  int (*proc [SXEVENTS + WMEXTEND])();

  TSCurResSet (localRscHdl);

  /* icon p^[̎擾		*/

  {
    iconImgHdl = (rectImg**) TSRscGet ('PAT4', 129);
    if (!iconImgHdl) {
      TSErrDialogN (1, "p^[f[^擾ł܂");
      tiniProc (0, 0);
    }
    TSRscDetach ((handle) iconImgHdl);
  }

  /* icon j[̎擾		*/

  {
    iconMenuHdl = MNRefer (129);
    if (!iconMenuHdl) {
      TSErrDialogN (1, "j[R[h擾ł܂");
      tiniProc (0, 0);
    }
    TSRscDetach ((handle) iconMenuHdl);
  }

  /* iconWindow ̕\ʒu^TCY擾	*/

  if (_window_pos_list [1].flag) {
    *(point_t *) &(boundsRect.left) = _window_pos_list [1].pos;
  } else {
    *(point_t *) &(boundsRect.left) = TSGetWindowPos ();
  }
  boundsRect.right  = boundsRect.left + ((rect*) *iconImgHdl)->right;
  boundsRect.bottom = boundsRect.top  + ((rect*) *iconImgHdl)->bottom;

  /* event [`̓o^		*/

  memset (proc, 0, sizeof (int (*)()) * (SXEVENTS + WMEXTEND));
  proc [E_IDLE]      = iconIdleEvent;
  proc [E_MSLDOWN]   = iconMouseLeftDownEvent;
  proc [E_MSRDOWN]   = iconMouseRightDownEvent;
  proc [E_KEYDOWN]   = keyDownEvent;
  proc [E_UPDATE]    = iconUpdateEvent;
  proc [E_ACTIVATE]  = activateEvent;
  proc [E_SYSTEM1]   = systemEvent;
  proc [E_SYSTEM2]   = systemEvent;
  proc [WM_DISPOSE]  = disposeIconWindow;
  proc [WM_SAVE_TDB] = saveTaskDB;

  /* iconWindow I[v		*/

  if (!windowOpen (
		   &iconWindow,
		   iconWindowWdefId,
		   iconWindowTitle,
		   &boundsRect,
		   NULL,
		   (windowNum << 8) | taskId,
		   proc,
		   iconWindowOption
		   )) {
    return 0;
  }

  return 1;
}

/* =====================================================================
 *  disposeIconWindow - iconWindow ̔p
 * =====================================================================
 */

static int
disposeIconWindow (void)
{
  /* icon p^[̔p		*/

  handleDispose ((handle) iconImgHdl);
  iconImgHdl = NULL;

  /* icon j[̔p		*/

  handleDispose ((handle) iconMenuHdl);
  iconMenuHdl = NULL;

  return 1;
}

/* =====================================================================
 *  saveTaskDB - task data base XV̏
 * =====================================================================
 */

static int
saveTaskDB (char* cmd)
{
  point_t pos = windowPos (&iconWindow);

  sprintf (cmd + strlen (cmd), "-s1,%08x ", pos);

  return 1;
}

/* =====================================================================
 *  idleEvent - for idle event
 * =====================================================================
 */

static int
iconIdleEvent (void)
{
  return 1;
}

/* =====================================================================
 *  mouseLeftDownEvent - for mouseLefetDown event
 * =====================================================================
 */

static int
iconMouseLeftDownEvent (void)
{
  if (thisWindow->windowPtr == (window*) eventRecord.whom) {
    static unsigned lastClick = 0;
    int partCode;

    if ((EMSysTime () - lastClick) < EMDClickGet ()) {
      windowHide (&iconWindow);
      windowShow (&mainWindow);
      movieShow (movieHdl);
      return 1;
    } else {
      lastClick = EMSysTime ();
    }

    if (!chkopt1 (&eventRecord) && !thisWindow->activeFlag) {
      WMSelect (thisWindow->windowPtr);
    }

    GMSetGraph ((graph*) thisWindow->windowPtr);
    partCode = SXCallWindM2 (thisWindow->windowPtr, &eventRecord, &(thisWindow->growRect));
    thisWindow->boundsRect = thisWindow->windowPtr->wGraph.grRect;
  }

  return 1;
}

/* =====================================================================
 *  mouseRightDownEvent - for mouseRightDown event
 * =====================================================================
 */

static int
iconMouseRightDownEvent (void)
{
  if (thisWindow->windowPtr == (window*) eventRecord.whom) {
    int menuItem;

    GMSetGraph ((graph*) thisWindow->windowPtr);
    menuItem = MNSelect (iconMenuHdl, eventRecord.whom2);
    switch (menuItem) {
    case 1:
      windowShow (&infoWindow);
      break;
    case 3:
      windowHide (thisWindow);
      windowShow (&mainWindow);
      movieShow (movieHdl);
      break;
    case 4:
      tiniProc (0, 0);
      break;
    }
  }

  return 1;
}

/* =====================================================================
 *  updateEvent - for update event
 * =====================================================================
 */

static int
iconUpdateEvent (void)
{
  if (thisWindow->windowPtr == (window*) eventRecord.whom) {
    GMSetGraph ((graph*) thisWindow->windowPtr);

    WMUpdate (thisWindow->windowPtr);

    GMSetGraph ((graph*) thisWindow->windowPtr);
    GMPutRImg (*iconImgHdl, 0);

    WMUpdtOver (thisWindow->windowPtr);
  }

  return 1;
}

/* =====================================================================
 *  end of icon.c
 * =====================================================================
 * $Log: icon.c,v $
 * Revision 1.11  1994/01/03  08:00:32  hidori
 * E'mTCH' Ȃ .FLM ̍ăT|[g
 *
 * Revision 1.10  1993/09/11  07:23:24  hidori
 * Ej[ACe "hLg" ̍폜
 *
 * Revision 1.9  1993/09/04  02:45:34  hidori
 * E_uNbNɂEBhEs
 *
 * Revision 1.8  1993/08/22  14:42:09  hidori
 * Ej[nh̉ύX
 *
 * Revision 1.7  1993/08/16  16:35:40  hidori
 * EAbvf[g̕ύX
 *
 * Revision 1.6  1993/08/14  13:01:14  hidori
 * EmovieHide ւ̑Ή
 *
 * Revision 1.5  1993/08/14  12:15:28  hidori
 * EWM_SAVE_TDB \bhւ̑Ή
 *
 * Revision 1.4  1993/08/13  03:16:51  hidori
 * Ewindow \bh̐錾e window \[X̐擪Ɉړ
 *
 * Revision 1.3  1993/08/12  16:34:06  hidori
 * EACRp^[TCYEBhETCY肷悤ɕύX
 * EEBhEpɃACRp^[̃nhp悤ɕύX
 *
 * Revision 1.2  1993/08/11  11:16:06  hidori
 * E^C`[g̎QƂ
 * E|[Y̎
 *
 * Revision 1.1  1993/08/05  13:51:09  hidori
 * Initial revision
 *
 */
