/* =====================================================================
 *  info.c - information window
 * =====================================================================
 * $Revision: 1.7 $
 * $Date: 1993/09/11 07:23:24 $
 * $Author: hidori $
 */

static const char rcsid [] = "$Id: info.c,v 1.7 1993/09/11 07:23:24 hidori Exp $";

#define	INFO_WINDOW

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/dos.h>

#include <sxlib.h>

#include "Skel.h"

/* =====================================================================
 *  prototype
 * =====================================================================
 */

extern int openIndoWindow    (int windowNum);
static int disposeInfoWindow (void);
static int saveTaskDB        (char* cmd);

static int infoIdleEvent          (void);
static int infoMouseLeftDownEvent (void);
extern int keyDownEvent           (void);
static int infoUpdateEvent        (void);
extern int activateEvent          (void);

/* =====================================================================
 *  global
 * =====================================================================
 */

static rectImg** logoImgHdl;
static rectImg** iconImgHdl;

/* =====================================================================
 *  openInfoWindow - infoWindow ̃I[v
 * =====================================================================
 */

int
openInfoWindow (int windowNum)
{
  rect boundsRect;
  int (*proc [SXEVENTS + WMEXTEND])();

  TSCurResSet (localRscHdl);

  /* logo p^[̎擾		*/

  {
    logoImgHdl = (rectImg**) TSRscGet ('PAT4', 128);
    if (!logoImgHdl) {
      TSErrDialogN (1, "p^[f[^擾ł܂");
      tiniProc (0, 0);
    }
    TSRscDetach ((handle) logoImgHdl);
  }

  /* icon p^[̎擾		*/

  {
    iconImgHdl = (rectImg**) TSRscGet ('PAT4', 129);
    if (!iconImgHdl) {
      TSErrDialogN (1, "p^[f[^擾ł܂");
      tiniProc (0, 0);
    }
    TSRscDetach ((handle) iconImgHdl);
  }

  /* infoWindow ̕\ʒu^TCY擾	*/

  if (_window_pos_list [2].flag) {
    *(point_t *) &(boundsRect.left) = _window_pos_list [2].pos;
  } else {
    *(point_t *) &(boundsRect.left) = TSGetWindowPos ();
  }
  boundsRect.right  = boundsRect.left + infoWindowWidth;
  boundsRect.bottom = boundsRect.top  + infoWindowHeight;

  /* event [`̓o^		*/

  memset (proc, 0, sizeof (int (*)()) * (SXEVENTS + WMEXTEND));
  proc [E_IDLE]      = infoIdleEvent;
  proc [E_MSLDOWN]   = infoMouseLeftDownEvent;
  proc [E_KEYDOWN]   = keyDownEvent;
  proc [E_UPDATE]    = infoUpdateEvent;
  proc [E_ACTIVATE]  = activateEvent;
  proc [WM_DISPOSE]  = disposeInfoWindow;
  proc [WM_SAVE_TDB] = saveTaskDB;

  /* window IvV̐ݒ		*/

  if (!windowOpen (
		   &infoWindow,
		   infoWindowWdefId,
		   infoWindowTitle,
		   &boundsRect,
		   NULL,
		   (windowNum << 8) | taskId,
		   proc,
		   infoWindowOption
		   )) {
    return 0;
  }

  return 1;
}

/* =====================================================================
 *  disposeInfoWindow - infoWindow ̔p
 * =====================================================================
 */

static int
disposeInfoWindow (void)
{
  /* logo p^[̔p		*/

  handleDispose ((handle) logoImgHdl);
  logoImgHdl = NULL;

  /* icon p^[̔p		*/

  handleDispose ((handle) iconImgHdl);
  iconImgHdl = NULL;

  return 1;
}

/* =====================================================================
 *  saveTaskDB - task data base XV̏
 * =====================================================================
 */

static int
saveTaskDB (char* cmd)
{
  point_t pos = windowPos (&infoWindow);

  sprintf (cmd + strlen (cmd), "-s2,%08x ", pos);

  return 1;
}

/* =====================================================================
 *  idleEvent - for idle event
 * =====================================================================
 */

static int
infoIdleEvent (void)
{
  return 1;
}

/* =====================================================================
 *  mouseLeftDownEvent - for mouseLefetDown event
 * =====================================================================
 */

static int
infoMouseLeftDownEvent (void)
{
  if (thisWindow->windowPtr == (window*) eventRecord.whom) {
    int partCode;
    int closeflag = 1;

    if (!chkopt1 (&eventRecord) && !thisWindow->activeFlag) {
      WMSelect (thisWindow->windowPtr);
      closeflag = 0;
    }

    GMSetGraph ((graph*) thisWindow->windowPtr);
    partCode = SXCallWindM2 (thisWindow->windowPtr, &eventRecord, &(thisWindow->growRect));
    switch (partCode) {
    case W_INCLOSE:
      if (closeflag) {
	thisWindow->option |= WINDOW_OPT_HIDE;
	WMHide (thisWindow->windowPtr);
	WMSelect2 (thisWindow->windowPtr, 0);
      }
      break;
    }
  }

  return 1;
}

/* =====================================================================
 *  updateEvent - for update event
 * =====================================================================
 */

static int
infoUpdateEvent (void)
{
  if (thisWindow->windowPtr == (window*) eventRecord.whom) {
    point pt;

    GMSetGraph ((graph*) thisWindow->windowPtr);

    WMUpdate (thisWindow->windowPtr);

    {
      pt = (point) {16, 16};
      GMPutRImg (*iconImgHdl, *(point_t*) &pt);

      pt = (point) {77, 4};
      GMPutRImg (*logoImgHdl, *(point_t*) &pt);
    }

    {
      GMForeColor (G_WHITE);
      pt = (point) {  0, 77};
      GMMove (*(point_t*) &pt);
      pt = (point) {384, 77};
      GMLine (*(point_t*) &pt);

      GMForeColor (G_BLACK);
      pt = (point) {  0, 78};
      GMMove (*(point_t*) &pt);
      pt = (point) {384, 78};
      GMLine (*(point_t*) &pt);

      GMForeColor (thisWindow->foreColor);
    }

    WMUpdtOver (thisWindow->windowPtr);
  }

  return 1;
}

/* =====================================================================
 *  end of info.c
 * =====================================================================
 * $Log: info.c,v $
 * Revision 1.7  1993/09/11  07:23:24  hidori
 * EANeBxCgꕔύX
 *
 * Revision 1.6  1993/08/16  16:35:40  hidori
 * EAbvf[g̕ύX
 *
 * Revision 1.5  1993/08/14  12:15:28  hidori
 * EWM_SAVE_TDB \bhւ̑Ή
 *
 * Revision 1.4  1993/08/13  03:16:51  hidori
 * Ewindow \bh̐錾e window \[X̐擪Ɉړ
 * EmouseLeftDown ̋ύX
 * 				(Thanks to Niggle)
 *
 * Revision 1.3  1993/08/12  16:34:06  hidori
 * EEBhEpɃACRp^[̃nhp悤ɕύX
 * EEBhEpɃS}[Ñnhp悤ɕύX
 *
 * Revision 1.2  1993/08/11  11:16:06  hidori
 * E^C`[g̎QƂ
 * E|[Y̎
 *
 * Revision 1.1  1993/08/05  13:51:09  hidori
 * Initial revision
 *
 */
