/* =====================================================================
 *  main.c - main window
 * =====================================================================
 * $Revision: 1.18 $
 * $Date: 1994/01/04 19:33:23 $
 * $Author: hidori $
 */

static const char rcsid [] = "$Id: main.c,v 1.18 1994/01/04 19:33:23 hidori Exp hidori $";

#define	MAIN_WINDOW

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/dos.h>

#include <sxlib.h>

#include "Skel.h"
#include "MOVIE.h"

/* =====================================================================
 *  prototype
 * =====================================================================
 */

extern int openMainWindow    (int windowNum);
static int disposeMainWindow (void);
static int saveTaskDB        (char* cmd);

extern int idleEvent	       (void);
extern int mouseLeftDownEvent  (void);
extern int mouseLeftUpEvent    (void);
extern int mouseRightDownEvent (void);
extern int mouseRightUpEvent   (void);
extern int keyDownEvent	       (void);
extern int keyUpEvent	       (void);
extern int updateEvent	       (void);
extern int activateEvent       (void);
extern int systemEvent	       (void);
extern int userEvent	       (void);

/* =====================================================================
 *  global
 * =====================================================================
 */

EXTERN MOVIE** movieHdl;
EXTERN rect movieRect;
EXTERN char movieFilename [MOVIE_FILENAMEL];
EXTERN char movieTitle [MOVIE_FILENAMEL];

EXTERN int movieKick;

static menu** mainMenuHdl;

control** playBttn;
control** pauseBttn;
control** stopBttn;

/* =====================================================================
 *  openMainWindow - mainWindow ̃I[v
 * =====================================================================
 */

int
openMainWindow (int windowNum)
{
  rect boundsRect, growRect;
  int (*proc [SXEVENTS + WMEXTEND])();

  TSCurResSet (localRscHdl);

  /* main j[̎擾		*/

  {
    mainMenuHdl = MNRefer (128);
    if (!mainMenuHdl) {
      TSErrDialogN (1, "j[R[h擾ł܂");
      tiniProc (0, 0);
    }
    TSRscDetach ((handle) mainMenuHdl);
  }

  /* mainWindow ̕\ʒu^TCY擾	*/

  {
    task taskBuf;

    TSGetTdb (&taskBuf, -1);
    if (!(1 & TSTakeParam (&taskBuf.command, &boundsRect, 0, 0, 0, 0))) {
      *(unsigned long *) (&boundsRect.left) = TSGetWindowPos ();
      boundsRect.right  = boundsRect.left + mainWindowWidth;
      boundsRect.bottom = boundsRect.top  + mainWindowHeight;
    }
  }

  /* TCY͈͂̐ݒ			*/

  growRect = (rect) {
    mainWindowWidthMin, mainWindowHeightMin,
    mainWindowWidthMax, mainWindowHeightMax,
  };

  /* event [`̓o^		*/

  memset (proc, 0, sizeof (int (*)()) * (SXEVENTS + WMEXTEND));
  proc [E_IDLE]      = idleEvent;
  proc [E_MSLDOWN]   = mouseLeftDownEvent;
  proc [E_MSRDOWN]   = mouseRightDownEvent;
  proc [E_KEYDOWN]   = keyDownEvent;
  proc [E_UPDATE]    = updateEvent;
  proc [E_ACTIVATE]  = activateEvent;
  proc [E_SYSTEM1]   = systemEvent;
  proc [E_SYSTEM2]   = systemEvent;
  proc [WM_DISPOSE]  = disposeMainWindow;
  proc [WM_SAVE_TDB] = saveTaskDB;
  
  if (!windowOpen (
		   &mainWindow,
		   mainWindowWdefId,
		   mainWindowTitle,
		   &boundsRect,
		   &growRect,
		   taskId,
		   proc,
		   mainWindowOption
		   )) {
    return 0;
  }

#ifdef USE_CTRL_PANEL
  /* ctrl ̎擾			*/

  {
    rect bttnBounds;
    point pt;
    rectImg** bttnImg;

    GMSetGraph ((graph*) mainWindow.windowPtr);

    bttnImg = (rectImg**) TSRscGet ('PAT4', 256);
    if (!bttnImg) return 0;
    TSRscDetach ((handle) bttnImg);

    bttnBounds = *(rect*) *bttnImg;
    bttnBounds.bottom += 4;
    bttnBounds.right  += 4;
    pt = (point) {0, windowHeight (&mainWindow) - 16};
    GMMoveRect (&bttnBounds, *(point_t*) &pt);

    playBttn = CMOpen (mainWindow.windowPtr, &bttnBounds, (LASCII*) "\@",
		       -1, 0, 0, 1,
		       128 * 16 + 4, (long) bttnImg);
    if (!playBttn) {
      TSErrDialogN (1, "Control can't open.");
      handleDispose ((handle) bttnImg);
      bttnImg = NULL;
    }

    bttnImg = (rectImg**) TSRscGet ('PAT4', 257);
    if (!bttnImg) return 0;
    TSRscDetach ((handle) bttnImg);

    bttnBounds = *(rect*) *bttnImg;
    bttnBounds.bottom += 4;
    bttnBounds.right  += 4;
    pt = (point) {17, windowHeight (&mainWindow) - 16};
    GMMoveRect (&bttnBounds, *(point_t*) &pt);

    pauseBttn = CMOpen (mainWindow.windowPtr, &bttnBounds, (LASCII*) "\@",
			-1, 0, 0, 1,
			128 * 16 + 4, (long) bttnImg);
    if (!pauseBttn) {
      TSErrDialogN (1, "Control can't open.");
      handleDispose ((handle) bttnImg);
      bttnImg = NULL;
    }

    bttnImg = (rectImg**) TSRscGet ('PAT4', 258);
    if (!bttnImg) return 0;
    TSRscDetach ((handle) bttnImg);

    bttnBounds = *(rect*) *bttnImg;
    bttnBounds.bottom += 4;
    bttnBounds.right  += 4;
    pt = (point) {34, windowHeight (&mainWindow) - 16};
    GMMoveRect (&bttnBounds, *(point_t*) &pt);

    stopBttn = CMOpen (mainWindow.windowPtr, &bttnBounds, (LASCII*) "\@",
		       -1, 0, 0, 1,
		       128 * 16 + 4, (long) bttnImg);
    if (!stopBttn) {
      TSErrDialogN (1, "Control can't open.");
      handleDispose ((handle) bttnImg);
      bttnImg = NULL;
    }
  }
#endif /* USE_CTRL_PANEL */

  return 1;
}

/* =====================================================================
 *  disposeMainWindow - mainWindow ̔p
 * =====================================================================
 */

int
disposeMainWindow (void)
{
  /* main j[̔p		*/

  handleDispose ((handle) mainMenuHdl);
  mainMenuHdl = NULL;

  /* movie ̔p			*/

  movieDispose (movieHdl);
  movieHdl = NULL;

  return 1;
}

/* =====================================================================
 *  saveTaskDB - task data base XV̏
 * =====================================================================
 */

int
saveTaskDB (char* cmd)
{
  if (*movieFilename) {
    sprintf (cmd + strlen (cmd), "%s ", movieFilename);
  }

  if (movieHdl) {
    sprintf (cmd + strlen (cmd), "-z%s ", movieGetStatusStr (movieHdl));
  }

  sprintf (cmd + strlen (cmd), "-t%s ", ltoz (&(mainWindow.title)));

  return 1;
}

/* =====================================================================
 *  idleEvent - for idle event
 * =====================================================================
 */

int
idleEvent (void)
{
  GMSetGraph ((graph*) mainWindow.windowPtr);

  if (movieKick) {
    movieKick = 0;
    moviePlay (movieHdl);
  }

  movieDraw (movieHdl, &eventRecord);

  if (!(thisWindow->option & WINDOW_OPT_HIDE)) {
    if (thisWindow->updateFlag) {
      thisWindow->updateFlag = 0;

      {
	point start = (point) {
	  (((mainWindow.windowPtr)->wGraph).grRect).left,
	  (((mainWindow.windowPtr)->wGraph).grRect).bottom - hscBarHeight,
	};
	point end = (point) {
	  (((mainWindow.windowPtr)->wGraph).grRect).right,
	  (((mainWindow.windowPtr)->wGraph).grRect).bottom - hscBarHeight,
	};

	int lastPages = GMAPage (0x0f);
	int lastColor = GMForeColor (G_BLACK);
	int lastMode  = GMPenMode (G_PSET);

	GMMove (*(point_t*) &start);
	GMLine (*(point_t*) &end);

	GMAPage (lastPages);
	GMForeColor (lastColor);
	GMPenMode (lastMode);
      }

      CMDraw (thisWindow->windowPtr);
    }
  }

  return 1;
}

/* =====================================================================
 *  mouseLeftDownEvent - for mouseLefetDown event
 * =====================================================================
 */

int
mouseLeftDownEvent (void)
{
  if (thisWindow->windowPtr == (window*) eventRecord.whom) {
    int partCode;
    int closeflag = 1;

    if (!chkopt1 (&eventRecord) && !thisWindow->activeFlag) {
      WMSelect (thisWindow->windowPtr);
      closeflag = 0;
    }

    GMSetGraph ((graph*) thisWindow->windowPtr);
    partCode = SXCallWindM2 (thisWindow->windowPtr, &eventRecord, &(thisWindow->growRect));
    thisWindow->boundsRect = thisWindow->windowPtr->wGraph.grRect;

    switch (partCode) {
    case W_ININSIDE:
      {
	control** targetCtrl;
	int partCode = SXCallCtrlM (thisWindow->windowPtr, &eventRecord,
				    NULL, NULL, NULL,
				    &targetCtrl);
	switch (partCode) {
	case C_INBTTN:
	  if (targetCtrl == playBttn) {
	    moviePlay (movieHdl);
	  } else if (targetCtrl == pauseBttn) {
	    moviePauseInvert (movieHdl);
	  }else if (targetCtrl == stopBttn) {
	    tsevent dummyEventRecord = eventRecord;

	    movieStop (movieHdl);
	    dummyEventRecord.what = E_UPDATE;
	    movieDraw (movieHdl, &dummyEventRecord);
	  }
	  thisWindow->updateFlag = 1;
	  break;
	}
      }
      break;
    case W_INGROW:
    case W_INZMOUT:
    case W_INZMIN:
      thisWindow->updateFlag = 1;
      break;
    case W_INCLOSE:
      if (closeflag) tiniProc (0, 0);
      break;
    }
  }

  return 1;
}

/* =====================================================================
 *  mouseRightDownEvent - for mouseRightDown event
 * =====================================================================
 */

int
mouseRightDownEvent (void)
{
  if (thisWindow->windowPtr == (window*) eventRecord.whom) {
    int menuItem;

    menuCheckItem (mainMenuHdl, 3, (movieHdl ? (*movieHdl)->pause  : 0));
    menuCheckItem (mainMenuHdl, 4, (movieHdl ? (*movieHdl)->play   : 0));
    menuCheckItem (mainMenuHdl, 5, (movieHdl ? (*movieHdl)->repeat : 0));

    GMSetGraph ((graph*) thisWindow->windowPtr);
    menuItem = MNSelect (mainMenuHdl, eventRecord.whom2);
    switch (menuItem) {
    case 1:
      windowShow (&infoWindow);
      break;
    case 3:
      moviePauseInvert (movieHdl);
      thisWindow->updateFlag = 1;
      break;
    case 4:
      {
	tsevent dummyEventRecord = eventRecord;

	moviePlayInvert (movieHdl);
	dummyEventRecord.what = E_UPDATE;
	movieDraw (movieHdl, &dummyEventRecord);

	thisWindow->updateFlag = 1;
      }
      break;
    case 5:
      movieRepeatInvert (movieHdl);
      thisWindow->updateFlag = 1;
      break;
    case 7:
      movieHide (movieHdl);
      windowHide (thisWindow);
      windowShow (&iconWindow);
      break;
    case 8:
      tiniProc (0, 0);
      break;
    }
  }

  return 1;
}

/* =====================================================================
 *  keyDownEvent - for keyDown event
 * =====================================================================
 */

int
keyDownEvent (void)
{
  if (thisWindow->activeFlag && chkopt1 (&eventRecord)) {
    switch (byteof (eventRecord.whom)) {
    case 'I':
    case 'i':
      if (thisWindow == &mainWindow || thisWindow == &iconWindow) {
	windowShow (&infoWindow);
      }
      break;
    case 'S':
    case 's':
      if (thisWindow == &mainWindow) {
	if (movieHdl) moviePauseInvert (movieHdl);
	thisWindow->updateFlag = 1;
      }
      break;
    case 'D':
    case 'd':
      if (thisWindow == &mainWindow) {
	tsevent dummyEventRecord = eventRecord;

	moviePlayInvert (movieHdl);
	dummyEventRecord.what = E_UPDATE;
	movieDraw (movieHdl, &dummyEventRecord);

	thisWindow->updateFlag = 1;
      }
      break;
    case 'T':
    case 't':
      if (thisWindow == &mainWindow || thisWindow == &iconWindow) {
	windowHide (thisWindow);
	if (thisWindow == &mainWindow) {
	  movieHide (movieHdl);
	  windowShow (&iconWindow);
	} else if (thisWindow == &iconWindow) {
	  windowShow (&mainWindow);
	  movieShow (movieHdl);
	}
      }
      break;
    case 'Q':
    case 'q':
      if (thisWindow == &mainWindow || thisWindow == &iconWindow) {
	tiniProc (0, 0);
      }
      break;
    }

    TSGetEvent (EM_KEYDOWN, &eventRecord);
  }

  return 1;
}

/* =====================================================================
 *  updateEvent - for update event
 * =====================================================================
 */

int
updateEvent (void)
{
  if (thisWindow->windowPtr == (window*) eventRecord.whom) {
    GMSetGraph ((graph*) thisWindow->windowPtr);
    thisWindow->updateFlag = 1;

    WMUpdate (thisWindow->windowPtr);

    if (!(thisWindow->option & WINDOW_OPT_HIDE)) {
      if (thisWindow->option & WINDOW_OPT_GROWBOX) {
	WMDrawGBox (thisWindow->windowPtr);
      }
    }

    movieDraw (movieHdl, &eventRecord);

    {
      point start = (point) {
	(((mainWindow.windowPtr)->wGraph).grRect).left,
	(((mainWindow.windowPtr)->wGraph).grRect).bottom - hscBarHeight,
      };
      point end = (point) {
	(((mainWindow.windowPtr)->wGraph).grRect).right,
	(((mainWindow.windowPtr)->wGraph).grRect).bottom - hscBarHeight,
      };

      int lastPages = GMAPage (7);
      int lastColor = GMForeColor (G_BLACK);
      int lastMode  = GMPenMode (G_PSET);

      GMMove (*(point_t*) &start);
      GMLine (*(point_t*) &end);

      GMAPage (lastPages);
      GMForeColor (lastColor);
      GMPenMode (lastMode);
    }

    CMDraw (thisWindow->windowPtr);

    WMUpdtOver (thisWindow->windowPtr);
  }

  return 1;
}

/* =====================================================================
 *  activeEvent - for active event
 * =====================================================================
 */

int
activateEvent (void)
{
  thisWindow->activeFlag = !!(thisWindow->windowPtr == (window*) eventRecord.whom);

  return 1;
}

/* =====================================================================
 *  systemEvent - for system event
 * =====================================================================
 */

int
systemEvent (void)
{
  switch (eventRecord.what2) {
  case ENDTSK:
  case CLOSEALL:
    tiniProc (0, 0);
    break;
  case SAVE:
    setTdb ();
    break;
  case WINDOWSELECT:
    WMSelect (thisWindow->windowPtr);
    break;
  case DRAGEND:
    if (thisWindow == &mainWindow || thisWindow == &iconWindow) {
      if (thisWindow->windowPtr == (window*) eventRecord.whom) {
	char path [MOVIE_FILENAMEL];
	drag* dragPtr;

	*path = 0;
	if (TSGetDrag (&dragPtr) == 0) {
	  char* cellPtr;
	  char* origin;

	  MMHdlLock ((handle) dragPtr->cellHdl);
	  cellPtr = origin = *(dragPtr->cellHdl);
	  while ((cellPtr - origin) < dragPtr->length) {
	    if (*(short*) cellPtr == 'FS') {
	      TSISRecToStr ((icstate*) (cellPtr + 8), path);
	      if (strlen (path)) {
		point newsize;

		TSEndDrag (0);
		if (movieHdl) movieDispose (movieHdl);
		movieHdl = movieOpen (path, (graph*) mainWindow.windowPtr, &movieRect, 0);
		if (!movieHdl) {
		  tsevent dummyEventRecord = eventRecord;

		  dummyEventRecord.what = E_UPDATE;
		  movieDraw (movieHdl, &dummyEventRecord);

		  mainWindow.updateFlag = 1;
		  iconWindow.updateFlag = 1;

		  *movieFilename = 0;
		} else {
		  if (thisWindow == &iconWindow) {
		    windowHide (&iconWindow);
		    windowShow (&mainWindow);
		    movieShow (movieHdl);
		  }

		  movieKick = 1;
		  mainWindow.updateFlag = 1;
		  newsize.x = (*movieHdl)->bounds.right;
#ifdef USE_CTRL_PANEL
		  newsize.y = (*movieHdl)->bounds.bottom + hscBarHeight;
#else /* !USE_CTRL_PANEL */
		  newsize.y = (*movieHdl)->bounds.bottom;
#endif /* USE_CTRL_PANEL */
		  windowShow (&mainWindow);
		  WMSize (mainWindow.windowPtr, *(point_t*) &newsize, 1);
		  strcpy (movieFilename, path);
#ifdef USE_CTRL_PANEL
		  if (playBttn) {
		    point newPos = (point) {
		      (((mainWindow.windowPtr)->wGraph).grRect).left,
		      (((mainWindow.windowPtr)->wGraph).grRect).bottom - 16,
		    };

		    CMHide (playBttn);
		    CMMove (playBttn, *(point_t*) &newPos);
		    CMShow (playBttn);
		  }

		  if (pauseBttn){
		    point newPos = (point) {
		      (((mainWindow.windowPtr)->wGraph).grRect).left + 17,
		      (((mainWindow.windowPtr)->wGraph).grRect).bottom - 16,
		    };

		    CMHide (pauseBttn);
		    CMMove (pauseBttn, *(point_t*) &newPos);
		    CMShow (pauseBttn);
		  }

		  if (stopBttn) {
		    point newPos = (point) {
		      (((mainWindow.windowPtr)->wGraph).grRect).left + 34,
		      (((mainWindow.windowPtr)->wGraph).grRect).bottom - 16,
		    };

		    CMHide (stopBttn);
		    CMMove (stopBttn, *(point_t*) &newPos);
		    CMShow (stopBttn);
		  }
#endif /* USE_CTRL_PANEL */
		}
		return 1;
	      } else {
		cellPtr += *(int*)(cellPtr + 4) + 8;
	      }
	    } else {
	      cellPtr += *(int*)(cellPtr + 4) + 8;
	    }
	  }
	}
	TSEndDrag (-1);
      }
    }
    break;
  }

  return 1;
}

/* =====================================================================
 *  userEvent - for user event
 * =====================================================================
 */

int
userEvent (void)
{
  return 1;
}

/* =====================================================================
 *  end of main.c
 * =====================================================================
 * $Log: main.c,v $
 * Revision 1.18  1994/01/04  19:33:23  hidori
 * EI[fBIĐɎbΉ
 *
 * Revision 1.17  1994/01/03  08:00:32  hidori
 * E'mTCH' Ȃ .FLM ̍ăT|[g
 *
 * Revision 1.16  1994/01/01  11:06:36  hidori
 * *** empty log message ***
 *
 * Revision 1.15  1993/09/11  07:23:24  hidori
 * Ej[ACe "hLg" ̍폜
 *
 * Revision 1.14  1993/09/04  02:45:34  hidori
 * EANeBxCg̃hOŁAspӂɏIȂ悤ɕύX
 *
 * Revision 1.13  1993/08/25  13:27:12  hidori
 * EACR^EBhẼV[gJbg OPT.1 + 'T' ɕύX
 *
 * Revision 1.12  1993/08/22  14:42:09  hidori
 * Ej[nh̉ύX
 *
 * Revision 1.11  1993/08/17  15:58:47  hidori
 * EEBhERec̃NbNŁuĐvƂ
 *
 * Revision 1.10  1993/08/16  16:35:40  hidori
 * EAbvf[g̕ύX
 * Ej[ꕔύX
 *
 * Revision 1.9  1993/08/16  13:41:59  hidori
 * EĐ~ɉΉ
 *
 * Revision 1.8  1993/08/15  02:56:45  hidori
 * EV[gJbg̓ꕔύX
 *
 * Revision 1.7  1993/08/14  17:55:32  hidori
 * E"[r" hOΉ
 * EĐԎ擾^ݒ胁\bhΉ
 *
 * Revision 1.6  1993/08/14  13:01:14  hidori
 * EmovieHide ւ̑Ή
 *
 * Revision 1.5  1993/08/14  12:15:28  hidori
 * EWM_SAVE_TDB \bhւ̑Ή
 *
 * Revision 1.4  1993/08/13  03:16:51  hidori
 * Ewindow \bh̐錾e window \[X̐擪Ɉړ
 * EmouseLeftDown ̋ύX
 * 				(Thanks to Niggle)
 *
 * Revision 1.3  1993/08/12  16:34:06  hidori
 * EEBhE쐬̕ύX
 *
 * Revision 1.2  1993/08/11  11:16:06  hidori
 * E^C`[g̎QƂ
 * E|[Y̎
 *
 * Revision 1.1  1993/08/05  13:51:09  hidori
 * Initial revision
 *
 */
