/* =====================================================================
 *  misc.h - miscellaneous functions
 * =====================================================================
 * $Revision: 1.2 $
 * $Date: 1993/08/16 16:35:40 $
 * $Author: hidori $
 */

#ifndef MISC_H
#define MISC_H

#include <stdlib.h>
#include <string.h>

#include <sxlib.h>

/* =====================================================================
 *  inline functions
 * =====================================================================
 */

/* =====================================================================
 *  ztol - ASCIIZ  s  LASCII ɕϊ l Ɋi[
 * =====================================================================
 *  return: l ꎩgԂ
 */

static inline LASCII*
ztol (char* s, LASCII* l)
{
  l->length = strlen (s);
  strcpy (l->Lstr, s);

  return l;
}

/* =====================================================================
 *  ltoz - LASCII  ASCIIZ ɕϊ
 * =====================================================================
 *  return: l ꎩgԂ
 */

static inline char*
ltoz (LASCII* l)
{
  static char buf [256];

  memcpy (buf, l->Lstr, l->length);
  buf [l->length] = 0;

  return buf;
}

/* =====================================================================
 *  chkopt1 - V[gJbgL[ (OPT.1) ̉̌o
 * =====================================================================
 *  return: 0 ... V[gJbgL[ĂȂ
 *          1 ...                 V@@@@@@
 */

static inline int
chkopt1 (tsevent* evt)
{
  return !! (EHM_OPT1 & evt->tskid);
}

/* =====================================================================
 *  rectWidth - rct ̕߂
 * =====================================================================
 *  return: rct ̕
 */

static inline int
rectWidth (rect* rct)
{
  return rct->right - rct->left;
}

/* =====================================================================
 *  rectHeight - rct ̍߂
 * =====================================================================
 *  return: rct ̍
 */

static inline int
rectHeight (rect* rct)
{
  return rct->bottom - rct->top;
}

/* =====================================================================
 *  sizeofRect - rct ̕A߂
 * =====================================================================
 *  return: rct ̕A(point_t ^)
 */

static inline point_t
sizeofRect (rect* r)
{
  point pt = (point) {r->right - r->left, r->bottom - r->top};

  return *(point_t*) &pt;
}

/* =====================================================================
 *  handleDispose - nhłȂ unlock Ĕp
 * =====================================================================
 */

static inline void
handleDispose (handle hdl)
{
  if (hdl) {
    MMHdlUnlock (hdl);
    MMHdlDispose (hdl);
  }
}

/* =====================================================================
 *  handleLock - nhłȂ lock
 * =====================================================================
 */

static inline void
handleLock (handle hdl)
{
  if (hdl) MMHdlLock (hdl);
}

/* =====================================================================
 *  handleUnlock - nhłȂ unlock
 * =====================================================================
 */

static inline void
handleUnlock (handle hdl)
{
  if (hdl) MMHdlUnlock (hdl);
}

/* =====================================================================
 *  resourceDispose - nhłȂ resource p
 * =====================================================================
 */

static inline void
resourceDispose (handle resHdl)
{
  if (resHdl) {
    TSCurResSet (resHdl);
    TSResRemove ();
  }
}

#endif /* MISC_H */

/* =====================================================================
 *  end of misc.h
 * =====================================================================
 * $Log: misc.h,v $
 * Revision 1.2  1993/08/16  16:35:40  hidori
 * EnhpȂǂ̃}Nǉ
 *
 * Revision 1.1  1993/08/05  13:51:09  hidori
 * Initial revision
 *
 */
